#ifndef __NSIMAGEPERMISSION_H__
#define __NSIMAGEPERMISSION_H__


#include "nsIImagePermission.h"
#include "nsCookie.h"
#include "xp_core.h"

#include "nsVoidArray.h"


class nsImagePermission : public nsIImagePermission
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIIMAGEPERMISSION

  nsImagePermission();
  virtual ~nsImagePermission();
  /* additional members */
  nsresult Init();

 protected:
  PRBool mInitted;

  static nsVoidArray* mDocPermissions;
  static nsVoidArray* mImgPermissions;
  
  static COOKIE_BehaviorEnum mImageBehavior;

  static COOKIE_BehaviorEnum GetBehaviorPref();
  static void SetBehaviorPref(COOKIE_BehaviorEnum x);

  static void RegisterPrefsCallbacks(void);

  static void ChangePermission(const char* aURL, PRBool bAllow, nsVoidArray* pArray);
  static PRBool LookupURL(const char* aURL, nsVoidArray* pArray, PRInt32& index);

  friend MODULE_PRIVATE int PR_CALLBACK imageBehaviorPrefChanged(const char * newpref, void * data);

 private:
  PRBool permitLoad(const char * image_url, const char *doc_url);
};


#endif // __NSIMAGEPERMISSION_H__
